#ifndef ECORE_EXE_EO_HH
#define ECORE_EXE_EO_HH
#include <Eo.h>

extern "C" {
#include "ecore_exe.eo.h"
#include "efl_control.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_control.eo.hh"
#include "eo_base.eo.hh"
namespace ecore { 
struct Exe;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::ecore::Exe> : ::std::true_type {}; } }

namespace eo_cxx {
namespace ecore { 
struct Exe {
   ::efl::eolian::return_traits<void>::type command_get( ::efl::eolian::out_traits< ::efl::eina::string_view>::type exe_cmd,  ::efl::eolian::out_traits<Ecore_Exe_Flags>::type flags) const;
   ::efl::eolian::return_traits<void>::type command_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type exe_cmd,  ::efl::eolian::in_traits<Ecore_Exe_Flags>::type flags) const;
   static Eo_Class const* _eo_class()
   {
      return ECORE_EXE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::ecore::Exe() const;
   operator ::ecore::Exe&();
   operator ::ecore::Exe const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Exe,  ::efl::Control,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Exe const ,  ::efl::Control const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace ecore { 
struct Exe : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Control)
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Exe( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Exe(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Exe(Exe const& other) = default;
   Exe(Exe&& other) = default;
   Exe& operator=(Exe const& other) = default;
   Exe& operator=(Exe&& other) = default;
   Exe()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Exe( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Exe(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<void>::type command_get( ::efl::eolian::out_traits< ::efl::eina::string_view>::type exe_cmd,  ::efl::eolian::out_traits<Ecore_Exe_Flags>::type flags) const;
   ::efl::eolian::return_traits<void>::type command_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type exe_cmd,  ::efl::eolian::in_traits<Ecore_Exe_Flags>::type flags) const;
   static Eo_Class const* _eo_class()
   {
      return ECORE_EXE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct data_get_event
   {
      static Eo_Event_Description const* description()
      { return ECORE_EXE_EVENT_DATA_GET; }
      typedef Ecore_Exe_Event_Data parameter_type;
   } const data_get_event;
   static struct data_error_event
   {
      static Eo_Event_Description const* description()
      { return ECORE_EXE_EVENT_DATA_ERROR; }
      typedef Ecore_Exe_Event_Data parameter_type;
   } const data_error_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Exe,  ::efl::Control,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Exe const ,  ::efl::Control const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Exe) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Exe>::value, "");
} 
#include "ecore_exe.eo.impl.hh"
#endif
